package org.openxri.admin.webpages.config;

import java.util.ArrayList;
import java.util.List;

import org.apache.wicket.Application;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.TextField;
import org.apache.wicket.markup.html.list.ListItem;
import org.apache.wicket.markup.html.list.ListView;
import org.apache.wicket.model.Model;
import org.openxri.admin.webapplication.OpenXRIAdminApplication;
import org.openxri.admin.webpages.BasePage;
import org.openxri.config.ServerConfig;

public class Index extends BasePage {

	private static final long serialVersionUID = 2297749911034720192L;

	private ListView configEntriesListView; 

	@SuppressWarnings("unchecked")
	public Index() {

		this.setTitle(this.getString("title"));

		ServerConfig openXRIConfig = ((OpenXRIAdminApplication) Application.get()).getOpenXRIServerConfig();
		
		// create and add components

		this.add(new Label("clazz", openXRIConfig.getClass().getName()));
		
		List<Object> keys = new ArrayList<Object> (openXRIConfig.getProperties().keySet());
		
		this.configEntriesListView = new ListView("configEntries", keys) {

			private static final long serialVersionUID = 4268418431817371342L;

			@Override
			protected void populateItem(ListItem item) {

				item.add(new ConfigForm("configForm", item.getModelObjectAsString()));
			}
		};

		this.add(this.configEntriesListView);
		this.add(new PersistForm("persistForm"));
	}

	private class ConfigForm extends Form {

		private static final long serialVersionUID = -4997945051308044322L;

		private Label configKey;
		private TextField configValue;

		public ConfigForm(String id, String key) {

			super(id);

			ServerConfig openXRIConfig = ((OpenXRIAdminApplication) Application.get()).getOpenXRIServerConfig();
			
			// create and add components

			String value = openXRIConfig.getProperties().getProperty(key);

			this.configKey = new Label("configKey", new Model(key));
			this.configValue = new TextField("configValue", new Model(value));

			this.add(this.configKey);
			this.add(this.configValue);
		}

		@Override
		protected void onSubmit() {

			ServerConfig openXRIConfig = ((OpenXRIAdminApplication) Application.get()).getOpenXRIServerConfig();
			
			String key = this.configKey.getModelObjectAsString();
			String value = this.configValue.getModelObjectAsString();

			openXRIConfig.getProperties().setProperty(key, value);

			Index.this.info(Index.this.getString("updatesuccess"));
		}
	}

	private class PersistForm extends Form {

		private static final long serialVersionUID = 3489357235957390717L;

		public PersistForm(String id ) {

			super(id);
		}

		@Override
		protected void onSubmit() {

//			ServerConfig openXRIConfig = ((OpenXRIAdminApplication) Application.get()).getOpenXRIServerConfig();
			
// TODO			openXRIConfig.persist();
			
			Index.this.info(Index.this.getString("persistsuccess"));
		}
	}
}
